﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api.Types;

namespace HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api {
  public interface IMatlabConnector : IDisposable {
    event Action<string> ErrorOccuredEvent;

    /// <summary>
    /// Executes a given matlab script.
    /// </summary>
    /// <param name="script"></param>
    void ExecuteScript(string script);

    /// <summary>
    /// Executes a matlab command.
    /// </summary>
    /// <param name="command"></param>
    void Execute(string command);

    /// <summary>
    /// Returns a dictionary with all available and supported variables from the matlab workspace.
    /// </summary>
    /// <returns></returns>
    IEnumerable<MLVariableInfo> GetVariablesFromScript(string script);

    /// <summary>
    /// 
    /// </summary>
    /// <param name="varName"></param>
    /// <returns></returns>
    object GetVariable(string varName);

    /// <summary>
    /// 
    /// </summary>
    /// <param name="varName"></param>
    /// <returns></returns>
    MLTimeseries GetTimeseries(string varName);

    /// <summary>
    /// 
    /// </summary>
    /// <param name="varName"></param>
    /// <returns></returns>
    MLDouble GetDouble(string varName);

    /// <summary>
    /// 
    /// </summary>
    /// <param name="varName"></param>
    /// <returns></returns>
    MLDoubleArray GetDoubleArray(string varName);
  }
}
